#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/device.h>
#include <linux/io.h>
#include <linux/timer.h>
#include <linux/slab.h>
#include <linux/gpio.h>
#include <asm/atomic.h>
#include <asm/uaccess.h>
#include <linux/err.h>
#include <linux/gpio.h>

#define GPIO_PINS 128
unsigned int v[GPIO_PINS] = { 0 };

struct gpio_chip vgpio_gpio_chip = { 0 };

static int vgpio_gpio_get(struct gpio_chip *chip, unsigned offset)
{
    printk("%s(): get GPIO bit %d.\n", __func__, offset);
    return v[offset];
}
static void vgpio_gpio_set(struct gpio_chip *chip, unsigned offset, int val)
{
    printk("%s(): set GPIO bit %d as %d\n", __func__, offset, val);
    v[offset] = val;
    return ;
}


static int vgpio_gpio_probe(void)
{
    int ret;
    vgpio_gpio_chip.ngpio = GPIO_PINS;
    vgpio_gpio_chip.label = "vgpio";
    /* base will take effect of /sys/class/gpio256 */
    vgpio_gpio_chip.base = 0x100;
    vgpio_gpio_chip.get = vgpio_gpio_get;
    vgpio_gpio_chip.set = vgpio_gpio_set;

    ret = gpiochip_add(&vgpio_gpio_chip);
    if (ret < 0) {
        printk("gpiochip_add failed with error %d\n", ret);
        return -1;
    }
    printk("%s(): registerred.\n", __func__);


    return 0;
}

static void __exit vgpio_gpio_remove(void)
{
    gpiochip_remove(&vgpio_gpio_chip);
    printk("%s(): unregisterred.\n", __func__);

}
module_init(vgpio_gpio_probe);
module_exit(vgpio_gpio_remove);
MODULE_LICENSE("GPL");
